using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraRotate : MonoBehaviour
{
    public Transform target;
    public float horizontalSpeed = 1;
    public float verticalSpeed = 1;
    public float zoomSpeed = 1;

    Vector3 offset;

    private void Start()
    {
        if (target)
        {
            offset = transform.position - target.position;
        }        
        else
        {
            target = new GameObject().transform;
            target.name = "Camera target";
            target.position = Vector3.zero;
            offset = transform.position;
        }
    }

    void Update()
    {
        transform.position = target.position + offset;
        if (Input.GetMouseButton(0) && target != null)
        {
            transform.RotateAround(target.position, Vector3.up, Input.GetAxis("Mouse X") * horizontalSpeed * Time.deltaTime * 360);
            transform.RotateAround(target.position, transform.TransformDirection(Vector3.right), -Input.GetAxis("Mouse Y") * verticalSpeed * Time.deltaTime * 360f);
        }
        if (Input.mouseScrollDelta.y != 0)
        {
            Camera.main.fieldOfView += 90f * Input.mouseScrollDelta.y * zoomSpeed * Time.deltaTime;
        }
        offset = transform.position - target.position;
    }
}
